class LicensesController < ApplicationController
  layout 'test' if MagicNumber['test_layout']
  before_filter :authenticate_admin!, :only => [:list, :browse]

  # GET /licenses
  # GET /licenses.json
  def index
    @licenses = License.list()

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @licenses.to_json(License.list_json_opt) }
    end
  end

  # GET /licenses/1
  # GET /licenses/1.json
  def show
    @license = License.show(params[:id])
    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @license.to_json(License.show_json_opt) }
    end
  end

  def list
    @licenses = License.all

    respond_to do |format|
      format.html { render layout: 'system' }
      format.json { render json: @licenses }
    end
  end

  def browse
    @license = License.find(params[:id])

    respond_to do |format|
      format.html { render layout: 'system' }
      format.json { render json: @license }
    end
  end
end
