#画像処理
require 'digest/md5'
require 'RMagick'
class ImagerTest
  @@tmb_w = 50
  @@tmb_h = 50
  
  def self.tmb_w
    @@tmb_w
  end
  
  def self.tmb_w=(v)
    @@tmb_w = v
  end
  
  def self.tmb_h
    @@tmb_h
  end
  
  def self.tmb_h=(v)
    @@tmb_h = v
  end
  
  def initialize bindata
    @binary = bindata
    @lib = bindata.split /\n/
    @ext= 'png'
  end
  
  def self.load bindata
    r = nil
    begin
      r = ImagerTest.new bindata
    rescue 
      r = false
    end
    r
  end
  
  def binary
    @binary
  end
  
  def lib
    @lib
  end
  
  def width
    @lib.first.size
  end
  
  def height
    @lib.size
  end
  
  def filesize
    @lib.join.size
  end
  
  def ext
    @ext
  end
  
  def md5
    'A'*32
  end
  
  def v
    @lib.map {|r| r.reverse}.join("\n")
  end
  
  def h
    @lib.reverse.join("\n")
  end
  
  def vh
    @lib.reverse.map {|r| r.reverse}.join("\n")
  end
  
  def to_gif
    @ext = 'gif'
    ImagerTest.load @lib.map {|r| r.upcase}.join("\n")
  end
  
  def to_thumbnail
    ImagerTest.load('i')
  end
  
  def thumbnail_size
    ImagerTest.fix_size_both ImagerTest.tmb_w, ImagerTest.tmb_h, self.width, self.height
  end
  
  #ただサイズ計算したいとき
  def self.thumbnail_size w, h
    ImagerTest.fix_size_both ImagerTest.tmb_w, ImagerTest.tmb_h, w, h
  end
  
  #サイズの調整（limw,limhに必ず収まるように合わせる）
  def self.fix_size_both(limw, limh, w, h)
    wr = if w > limw
      limw*100/w
    else
      100
    end
    hr = if h > limh
      limh*100/h
    else
      100
    end
    res = if wr < hr
      #幅の方が圧縮率が高い
      [w*wr/100, h*wr/100]
    else
      #高さの方が圧縮率が高い
      [w*hr/100, h*hr/100]
    end
    res
  end
  
end

=begin
i = ImagerTest.load "abc\ndef\nghi"
p i.binary
p i.lib
p i.width
p i.height
p i.filesize
p i.ext
p i.md5
p i.v
p i.h
p i.vh
p i.to_gif
p i.to_thumbnail
=end
